<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); // HTTP/1.0

global $rGameip, $rGameport, $rSvrname;

// User Settings
// Only change the variable values within this block

// Change this to a 1 in order to allow the passing of the bfserver_ip and bfserver_port
// Otherwise, you will HAVE to put your server's IP and Port into this script, regardless
// if you leave them blank below...
$allow_url = 1;

// Set this IP address to that of your Battlefield 1942 Server
// Note:  Leave this blank if you are going to pass the script the Server's IP Address from the URL  
$bfserver_ip_script = $rGameip;

// Port -- This should be ok as the default
// Note:  Leave this blank if you are going to pass the scrit the server's Port from the URL

$bfserver_port_script = $rGameport;

// Your HTML Template filename
$template_filename = "bf1942popup.php";
$server_down_template_filename = "bf1942popdown.php";

// Location of your Server - Thx to Prezident for this! -- CHANGE THIS TO WHATEVER YOU WANT
$bfserver_location = 'Idaho';

// OS of your Server
$bfserver_OS = 'Windows';

// End User Settings Block

// Do not change anything below this line!!
$bfprogram_version = "Beta 1.2.0l";

// IP Address of your Server

$bfserver_ip = '';		// These should have been predefined
$bfserver_port = '';

if (isset($_GET['bfserver_ip']) && $allow_url == 1) {
        $bfserver_ipX = "$_GET[bfserver_ip]";
} else {
	if ($bfserver_ip_script) {
        	$bfserver_ipX = $bfserver_ip_script;
	} else {
		echo "Error:  You need to specify the server's IP Address!<BR>";
		die;
	}
}

// IP Address of your Server
if (isset($_GET['bfserver_port']) && $allow_url == 1) {
        $bfserver_portX = "$_GET[bfserver_port]";
} else {
	if ($bfserver_port_script) {
        	$bfserver_portX = $bfserver_port_script;
	} else {
		echo "Error:  You need to specify the server's port number<br>";
		die;
	}
}

$bfserverinfo_template_keys2 = Array();
$bfserverinfo_key2 = Array();
$bfserverinfo_key2["serverlocation"] = $bfserver_location;
$bfserverinfo_key2["serveros"] = $bfserver_OS;

if (isset($_GET['debug_wintrmte'])) {
	echo "Opening UDP Connection to: $bfserver_ipX on port $bfserver_portX<BR>";
}

// Check the IP
if (!preg_match("/\d+\.\d+\.\d+\.\d+/", $bfserver_ipX)) {
	echo "IP Address: $bfserver_ipX does not appear to be valid.  Please use a valid IP Address<BR>";
	die;
}

$bfserverinfo_key2["bfserver_ipX"] = $bfserver_ipX;

$bfSocketp = fsockopen("udp://$bfserver_ipX", $bfserver_portX, $errno, $errstr);

if (!$bfSocketp) {
	echo "<strong>The server appears to be Offline</strong><br>Please try your request again later.<P>Error: $errno - $errstr<BR>";
	exit;
} else {
	@socket_set_timeout($bfSocketp, 2);
	fwrite ($bfSocketp, "\xff\\status\\") or die("Could not write to the server's socket");
	$header_bf1942server2 = fgets($bfSocketp, 2);

	if (isset($_GET['debug_wintrmte'])) {
       		echo "Head : $header_bf1942server<BR>";
		error_reporting(E_ALL);
	} else {
		error_reporting(0);
	}

	if (!$header_bf1942server2) {	// Meaning we didn't get anything back from the server so it must be down
		$bfserverinfo_key2["online"] = "Offline";
		read_template($server_down_template_filename);
		exit;
	} else { 
		$bfserverinfo_key2["online"] = "Online";
	} 

	$bfserver_do = true;
	$bfserver_str = '';
        $bfserver_data = '';
        $bfserver_data2 = '';

	// Grab the Server settings only
	while ($bfserver_do) {
		$bfserver_str = fgets($bfSocketp, 2); 	// This line is going to cause problems, I can tell
		$bfserver_data .= $bfserver_str;
		
		if ( preg_match("/queryid(.*)\.1/i", $bfserver_data)) {
			$bfserver_do = false;
		}
	}

	$bfserver_do = true;
	$char = 0;
	$bfserver_count = 0;
        $switch = '';
	$bfserver_str = '';
	while ($bfserver_do) {
		$char++;
		$bfserver_str = $bfserver_data[$char];
		if ($bfserver_str == "\\") {
			if ($switch) {
                                $switch = false;
                        } else {
                                $switch = true;
                                $bfserver_count++;
                        }
		}
		if ($bfserver_str == "\x10") $bfserver_do = false;
                if ($bfserver_str == null) $bfserver_do = false;
                if ($bfserver_str == "\x00") $bfserver_do = false;
	}

	$bfserver_do = true;
	$bfserver_completed = 0;
	$bfserver_switch = false;
	$bfserver_done = 1;

	if (isset($_GET['debug_wintrmte'])) {
		echo "<font color=\"white\">Debug:<hr size=\"3\">$bfserver_data<br><hr size=\"3\"><P>";
	}
	$bfserver_data = the_cleaner($bfserver_data, 0);

	for ($i = 1; $i <= $bfserver_count; $i++) {
		if (preg_match("/(.*?)\t(.*?)\t/i", $bfserver_data, $match) && $bfserver_data != '') {
			$bfserverinfo_key2[$match[1]] = $match[2];

			if (isset($_GET['debug_wintrmte'])) {
				echo "M1: $match[1]<br>M2: $match[2]<P>";
			}
			$bfserver_data = preg_replace("/$match[1]\t$match[2]\t/e", "", $bfserver_data);
		}
	}

	// End Server key population


        // Parse the Game Type and present it in a nice readable format
        // XPack1 = Road to Rome
        // desertcombat = Desert Combat
        // bf1942 = Standard Battlefield 1942

        if (preg_match("/bf1942/i", $bfserverinfo_key2["gameId"])) {
                $bfserverinfo_key2["gameId"] = "Standard Battlefield 1942";
        }
        if (preg_match("/desert/i", $bfserverinfo_key2["gameId"])) {
                $bfserverinfo_key2["gameId"] = "Desert Combat";
        }
	if (preg_match("/xpack1/i", $bfserverinfo_key2["gameId"])) {
                $bfserverinfo_key2["gameId"] = "Road to Rome";
        }




	// Start Player Score Population
	fwrite ($bfSocketp, "\xff\\info\players\\") or die("Could not write to the server's socket");
	$bfserver_do = true;
	$bfserver_str = '';
        $bfserver_data = '';

	while ($bfserver_do) {
                $bfserver_str = fgets($bfSocketp, 10);    // This line is going to cause problems, I can tell
                $bfserver_data .= $bfserver_str;
		 if (preg_match ("/final[\x5c\][\x5c\]queryid/i", $bfserver_data)) {
                                $bfserver_do = false;
                        }
        }

	// Player Stats
	$num = 0;
	if (isset($_GET['debug_wintrmte'])) {
		echo "Player Raw Data: <br>$bfserver_data<br><hr size=\"3\">";
        }
	$bfserver_data = the_cleaner($bfserver_data, 1); 

	for ($j = 1; $j <= $bfserverinfo_key2["numplayers"]; $j++) {
			 $bfserver_data = preg_replace("/\>/", "&gt;", $bfserver_data);
                         $bfserver_data = preg_replace("/\</", "&lt;", $bfserver_data);
			if ($bfserverinfo_key2["numplayers"] != 0 && preg_match("/team_(\d+)[\x5c\](\d+)[\x5c\]ping_(\d+)[\x5c\](\d+)[\x5c\]score_(\d+)[\x5c\](.*?)[\x5c\]deaths_(\d+)[\x5c\](\d+)[\x5c\]frags_(\d+)[\x5c\](\d+)[\x5c\]player_(\d+)[\x5c\](.*?)[\x5c\]/i", $bfserver_data, $playermatch)) {
				$num++;
				if (isset($_GET['debug_wintrmte'])) {
					echo "playerid $playermatch[1]<br>";
					echo "on team: $playermatch[2]<br>";
					echo "ping: $playermatch[4]<br>";
					echo "score: $playermatch[6]<br>";
					echo "deaths: $playermatch[8]<br>";
					echo "frags: $playermatch[10]<br>";
					echo "player_name: $playermatch[12]<br>";
					echo "<hr size=\"3\"><br>";
				}
				$player[$playermatch[1]][1] = $playermatch[2];	// On Team x
				$player[$playermatch[1]][2] = $playermatch[4];	// Ping
				$player[$playermatch[1]][3] = $playermatch[6];	// Score
				$player[$playermatch[1]][4] = $playermatch[8];	// Deaths
				$player[$playermatch[1]][5] = $playermatch[10];	// Frags
				$player[$playermatch[1]][6] = stripslashes($playermatch[12]); // Name
				$player[$playermatch[1]][7] = $playermatch[1];	// PlayerID
				$bfserver_data = preg_replace("/team_$playermatch[1][\x5c\]$playermatch[2][\x5c\]ping_$playermatch[1][\x5c\]$playermatch[4][\x5c\]score_$playermatch[1][\x5c\]$playermatch[6][\x5c\]deaths_$playermatch[1][\x5c\]$playermatch[8][\x5c\]frags_$playermatch[1][\x5c\]$playermatch[10][\x5c\]player_$playermatch[1][\x5c\]$playermatch[12][\x5c\]/e", "", $bfserver_data);
			}
	}

	$allied_count = 0;
	$axis_count = 0;
	$bfaxis_ping = 0;
	$bfaxis_score = 0;
	$bfaxis_deaths = 0;
	$bfaxis_frags = 0;
	$bfallied_score = 0;
	$bfallied_frags = 0;
	$bfallied_deaths = 0;
	$bfallied_ping = 0;
        $bfold_p = '';
        $allied_team = '';
        $axis_team = '';
	if (is_array($player)) {
		foreach (array_keys($player) as $p) {
			if ($bfold_p != $player[$p][6]) {
				if ($player[$p][1] == 2) {
					$bfplrid = '';
					$bfallied_ping = ($bfallied_ping + $player[$p][2]);
					$bfallied_score = ($bfallied_score + $player[$p][3]);
					$bfallied_frags = ($bfallied_frags + $player[$p][5]);
					$bfallied_deaths = ($bfallied_deaths + $player[$p][4]);
					$allied_count++;
					if (isset($_GET['dispid'])) {
						$bfplrid = $player[$p][7].". ";
					}
					$allied_team .= "<tr>\n<td width=\"170\"> &nbsp;".$player[$p][6]."</td>\n<td width=\"30\">".$player[$p][2]."</td>\n<td width=\"30\">".$player[$p][5]."</td>\n<td width=\"45\">".$player[$p][4]."</td>\n<td width=\"45\">".$player[$p][3]."</td>\n</tr>";
				} else {
					$bfplrid = '';
					$bfaxis_ping = ($bfaxis_ping + $player[$p][2]);
					$bfaxis_score = ($bfaxis_score + $player[$p][3]);
					$bfaxis_frags = ($bfaxis_frags + $player[$p][5]);
					$bfaxis_deaths = ($bfaxis_deaths + $player[$p][4]);
					$axis_count++;
					if (isset($_GET['dispid'])) {
                                                $bfplrid = $player[$p][7].". ";
                                        }
						$axis_team .= "<tr>\n<td width=\"170\"> &nbsp;".$player[$p][6]."</td>\n<td width=\"30\">".$player[$p][2]."</td>\n<td width=\"30\">".$player[$p][5]."</td>\n<td width=\"45\">".$player[$p][4]."</td>\n<td width=\"45\">".$player[$p][3]."</td>\n</tr>";
				}
			$bfold_p = $player[$p][6];
			}
		}
		$allied_team = the_stripper($allied_team);
		$axis_team = the_stripper($axis_team);
		// Compute the averages (Pings, Deaths, Score, Frags)
		$bfserverinfo_key2["allied_count"] = $allied_count;
		$bfserverinfo_key2["axis_count"] = $axis_count;

		$bfserverinfo_key2["allied_avg_ping"] = 0;
             $bfserverinfo_key2["allied_avg_score"] = 0;
             $bfserverinfo_key2["allied_avg_deaths"] = 0;
             $bfserverinfo_key2["allied_avg_frags"] = 0;
		$bfserverinfo_key2["axis_avg_ping"] = 0;
             $bfserverinfo_key2["axis_avg_score"] = 0;
             $bfserverinfo_key2["axis_avg_deaths"] = 0;
             $bfserverinfo_key2["axis_avg_frags"] = 0;

		if ($allied_count != 0) {
			if ($bfallied_ping != 0) {
				$bfserverinfo_key2["allied_avg_ping"] = round(($bfallied_ping / $allied_count));
			}
			if ($bfallied_score != 0) {
				$bfserverinfo_key2["allied_avg_score"] = round(($bfallied_score / $allied_count));
			}
			if ($bfallied_deaths != 0) {
				$bfserverinfo_key2["allied_avg_deaths"] = round(($bfallied_deaths / $allied_count));
			}
			if ($bfallied_frags != 0) {
				$bfserverinfo_key2["allied_avg_frags"] = round(($bfallied_frags / $allied_count));
			}
		}

		if ($axis_count != 0) {
			if ($bfaxis_ping != 0) {
				$bfserverinfo_key2["axis_avg_ping"] = round(($bfaxis_ping / $axis_count));
			}
			if ($bfaxis_score != 0) {
				$bfserverinfo_key2["axis_avg_score"] = round(($bfaxis_score / $axis_count));
			}
			if ($bfaxis_deaths != 0) {
				$bfserverinfo_key2["axis_avg_deaths"] = round(($bfaxis_deaths / $axis_count));
			}
			if ($bfaxis_frags != 0) {
				$bfserverinfo_key2["axis_avg_frags"] = round(($bfaxis_frags / $axis_count));
			}
		}
// REMARKED OUT THE FOLLOWING DOESNT APPLY TO SERVER VIEWER APPLICATION
/*		// Extra cell padding if they are offset
		if ($allied_count > $axis_count) {
			$bfserver_topad = ($allied_count - $axis_count);
			for ($bfs_a = 1; $bfs_a <= $bfserver_topad; $bfs_a++) {
				$axis_team .= "
<tr bgcolor=\"#4D5037\">\n
<td align=\"left\" valign=\"top\" background=\"images/plr-left-border.jpg\"><img src=\"images/plr-left-border.jpg\"></td>
<td align=\"left\">&nbsp;</td>\n
<td align=\"center\" bgcolor=\"#393D28\">&nbsp;</td>\n
<td align=\"center\">&nbsp;</td>\n
<td align=\"center\" bgcolor=\"#393D28\">&nbsp;</td>\n
<td align=\"center\">&nbsp;</td>\n
<td align=\"right\" background=\"images/plr-right-border.jpg\"><img src=\"images/plr-right-border.jpg\"></td>\n
</tr>";
			}
		$bfserver_topad = 0;
		}

		if ($axis_count > $allied_count) {
			$bfserver_topad = ($axis_count - $allied_count);
			for ($bfs_a = 1; $bfs_a <= $bfserver_topad; $bfs_a++) {
                                $allied_team .= "
<tr bgcolor=\"#525C2D\">\n
<td align=\"left\" valign=\"top\" background=\"images/plr-allied-left-border.jpg\"></td>
<td align=\"left\">&nbsp;</td>\n
<td align=\"center\" bgcolor=\"#393D28\">&nbsp;</td>\n
<td align=\"center\">&nbsp;</td>\n
<td align=\"center\" bgcolor=\"#393D28\">&nbsp;</td>\n
<td align=\"center\">&nbsp;</td>\n
<td align=\"right\" background=\"images/plr-allied-right-border.jpg\"><img src=\"images/plr-allied-right-border.jpg\"></td>\n
</tr>";
			}
		}
		$bfserver_topad = 0;
*/
// REMARKED OUT THE ABOVE BECAUSE DOESNT APPLY TO SERVER VIEWER APPLICATION

	}


	$footer = "<center><P><font size=\"2\">Created with <a href=\"http://jk2.gamersimpact.com\" target=\"new\">BattleStats</a> - Version $bfprogram_version.</font></center>";

	read_template($template_filename);
}

function the_stripper ($bfstrip) {
	$bftmpstrip = '';
	$bftmpstrip = $bfstrip;
	$bftmpstrip = str_replace("0x1PLUS", "+", $bftmpstrip);
	$bftmpstrip = str_replace("1x3ASTERISK", "*", $bftmpstrip);
	$bftmpstrip = str_replace("1x4APOS", "'", $bftmpstrip);
	$bftmpstrip = str_replace("BSL", "\\", $bftmpstrip);
	$bftmpstrip = str_replace("0xBFORWARDSLASH", "/", $bftmpstrip);
	$bftmpstrip = str_replace("0x7SQLB", "[", $bftmpstrip);
	$bftmpstrip = str_replace("0x8SQRB", "]", $bftmpstrip);
	$bftmpstrip = str_replace("0xCPIPE", "|", $bftmpstrip);
	$bftmpstrip = str_replace("0xDCARROT", "\^", $bftmpstrip);
	$bftmpstrip = str_replace("0xEQUESTION", "?", $bftmpstrip);
	$bftmpstrip = str_replace("0xFEXCLAM", "!", $bftmpstrip);
	$bftmpstrip = str_replace("0x4DOLLAR", "\$", $bftmpstrip);
	$bftmpstrip = str_replace("0x6ATSYMBOL", "@", $bftmpstrip);
	$bftmpstrip = str_replace("0x5TILDA", "~", $bftmpstrip);
	$bftmpstrip = str_replace("0xARPRN", "(", $bftmpstrip);
	$bftmpstrip = str_replace("0x9LPRN", ")", $bftmpstrip);
	$bftmpstrip = str_replace("1x1PERIOD", ".", $bftmpstrip);
	$bftmpstrip = str_replace("1x2COMMA", ",", $bftmpstrip);
	$bftmpstrip = str_replace("0x2LCURL", "}", $bftmpstrip);
	$bftmpstrip = str_replace("0x3RCURL", "{", $bftmpstrip);
	$bftmpstrip = str_replace("1x5SINQ", "`", $bftmpstrip);
	return($bftmpstrip);
}

function the_cleaner ($bfclean_me, $bfnotab) {
	$bftmpvar = '';
	$bftmpvar = $bfclean_me;
	if ($bfnotab == 0) {
		$bftmpvar = preg_replace("[\x5c\]", "\t", $bftmpvar);
	}
	// Remove any queryid that is in the middle of the stream
	$bftmpvar = preg_replace("/[\x2b]/", "0x1PLUS", $bftmpvar);
	$bftmpvar = preg_replace("/[\x7d]/", "0x2LCURL", $bftmpvar);
	$bftmpvar = preg_replace("/[\x7b]/", "0x3RCURL", $bftmpvar);
	$bftmpvar = preg_replace("/queryid[\x5c\](.*?)[\x5c\]/", "", $bftmpvar);
	$bftmpvar = preg_replace("/[\x24]/", "0x4DOLLAR", $bftmpvar);
	$bftmpvar = preg_replace("/[\x7e]/", "0x5TILDA", $bftmpvar);
	$bftmpvar = preg_replace("/[\x40]/", "0x6ATSYMBOL", $bftmpvar);
        $bftmpvar = preg_replace("/[\x5b]/", "0x7SQLB", $bftmpvar);
        $bftmpvar = preg_replace("/[\x5d]/", "0x8SQRB", $bftmpvar);
        $bftmpvar = preg_replace("/[\x29]/", "0x9LPRN", $bftmpvar);
        $bftmpvar = preg_replace("/[\x28]/", "0xARPRN", $bftmpvar);
        $bftmpvar = preg_replace("/[\x27]/", "1x4APOS", $bftmpvar);
	$bftmpvar = preg_replace("/[\x60]/", "1x5SINQ", $bftmpvar);
        $bftmpvar = preg_replace("/\//", "0xBFORWARDSLASH", $bftmpvar);
	$bftmpvar = preg_replace("/[\x7c]/", "0xCPIPE", $bftmpvar);
	$bftmpvar = preg_replace("/\^/", "0xDCARROT", $bftmpvar);
	$bftmpvar = preg_replace("/[\x3f]/", "0xEQUESTION", $bftmpvar);
	$bftmpvar = preg_replace("/[\x21]/", "0xFEXCLAM", $bftmpvar);
	$bftmpvar = preg_replace("/[\x2e]/", "1x1PERIOD", $bftmpvar);
	$bftmpvar = preg_replace("/[\x3e]/", "&gt;", $bftmpvar);
        $bftmpvar = preg_replace("/[\x3c]/", "&lt;", $bftmpvar);
	$bftmpvar = preg_replace("/[\x2c]/", "1x2COMMA", $bftmpvar);
	$bftmpvar = preg_replace("/[\x2a]/", "1x3ASTERISK", $bftmpvar);

	if ($bfnotab == 0) {
        	$bftmpvar = preg_replace("/\\\/", "BSL", $bftmpvar);
	}
        $bftmpvar = str_replace("*", "ASTERISK", $bftmpvar);
	return ($bftmpvar);
}

function read_template ($tf) {

	global $bfserverinfo_key2;
	global $footer;
	global $player;
	global $allied_team;
	global $axis_team;
	global $rMappics;
	$bfserverinfo_template_keys2['!ONLINESTATUS'] = $bfserverinfo_key2["online"];
	$bfserverinfo_template_keys2['!HOSTNAME'] = the_stripper($bfserverinfo_key2["hostname"]);
	$bfserverinfo_template_keys2["!MAXPLAYERS"] = $bfserverinfo_key2["maxplayers"];
	$bfserverinfo_template_keys2["!GAMEVERSION"] = $bfserverinfo_key2["gamever"];
	$bfserverinfo_template_keys2["!GAMENAME"] = $bfserverinfo_key2["gameId"];
	if ($bfserverinfo_key2["status"] == 4) {
		$bfserverinfo_template_keys2["!STATUS"] = "Good";
	} elseif ($bfserverinfo_key2["status"] == 3) {
		$bfserverinfo_template_keys2["!STATUS"] = "Medium";
	} else {
		$bfserverinfo_template_keys2["!STATUS"] = "Low";
	}
	if ($bfserverinfo_key2["password"] == 0) {
		$bfserverinfo_template_keys2["!PASSWORD"] = "No";
	} else {
		$bfserverinfo_template_keys2["!PASSWORD"] = "Yes";
	}
	$bfserverinfo_template_keys2["!GAMEMODE"] = the_stripper($bfserverinfo_key2["gamemode"]);
	$bfserverinfo_template_keys2["!MAXPLAYERS"] = the_stripper($bfserverinfo_key2["maxplayers"]);
	$bfserverinfo_template_keys2["!NUMPLAYERS"] = the_stripper($bfserverinfo_key2["numplayers"]);
	$bfserverinfo_template_keys2["!GAMETYPE"] = the_stripper($bfserverinfo_key2["gametype"]);
	$bfserverinfo_template_keys2["!MAPNAME"] = the_stripper($bfserverinfo_key2["mapname"]);
	$bfserverinfo_template_keys2["!CPU"] = the_stripper($bfserverinfo_key2["CPU"]);
	$bfserverinfo_template_keys2["!VEHICLEFFSPLASH"] = the_stripper($bfserverinfo_key2["Vehicle Friendly Fire On Splash"]);
	$bfserverinfo_template_keys2["!SOLDIERFFSPLASH"] = the_stripper($bfserverinfo_key2["Soldier Friendly Fire On Splash"]);
	$bfserverinfo_template_keys2["!KICKBACKSPLASH"] = the_stripper($bfserverinfo_key2["Kickback On Splash"]);
	$bfserverinfo_template_keys2["!KICKBACKVALUE"] = the_stripper($bfserverinfo_key2["Kickback"]);
	$bfserverinfo_template_keys2["!NAMETAGDISTANCESCOPE"] = the_stripper($bfserverinfo_key2["Name Tag Distance Scope"]);
	$bfserverinfo_template_keys2["!NAMETAGDISTANCE"] = the_stripper($bfserverinfo_key2["Name Tag Distance"]);
	$bfserverinfo_template_keys2["!AUTOBALANCE"] = the_stripper($bfserverinfo_key2["Auto Balance Teams"]);
	$bfserverinfo_template_keys2["!FOOTER"] = $footer;
	$bfserverinfo_template_keys2["!FREECAMERA"] = the_stripper($bfserverinfo_key2["Free Camera"]);
	$bfserverinfo_template_keys2["!BWCHOKELIMIT"] = the_stripper($bfserverinfo_key2["Bandwidth Choke Limit"]);
	$bfserverinfo_template_keys2["!AXISTEAMRATIO"] = the_stripper($bfserverinfo_key2["Axis Team Ratio"]);
	$bfserverinfo_template_keys2["!ALLIEDTEAMRATIO"] = the_stripper($bfserverinfo_key2["Allied Team Ratio"]);
	$bfserverinfo_template_keys2["!EXTERNALVIEW"] = the_stripper($bfserverinfo_key2["External View"]);
	$bfserverinfo_template_keys2["!ALLOWNOSECAM"] = the_stripper($bfserverinfo_key2["Allow Nose Cam"]);
	$bfserverinfo_template_keys2["!TICKETRATIO"] = the_stripper($bfserverinfo_key2["Ticket Ratio"]);
	$bfserverinfo_template_keys2["!GAMESTARTDELAY"] = the_stripper($bfserverinfo_key2["Game Start Delay"]);
	$bfserverinfo_template_keys2["!VEHICLEFF"] = the_stripper($bfserverinfo_key2["Vehicle Friendly Fire"]);
	$bfserverinfo_template_keys2["!SOLDIERFF"] = the_stripper($bfserverinfo_key2["Soldier Friendly Fire"]);
	$bfserverinfo_template_keys2["!SPAWNDELAY"] = the_stripper($bfserverinfo_key2["Spawn Delay"]);
	if ($bfserverinfo_key2["Number of Rounds"]) {
		$bfserverinfo_template_keys2["!NUMROUNDS"] = the_stripper($bfserverinfo_key2["Number of Rounds"]);
	} else {
		$bfserverinfo_template_keys2["!NUMROUNDS"] = "N/A";
	}
	$bfserverinfo_template_keys2["!DEDICATED"] = the_stripper($bfserverinfo_key2["Dedicated"]);
	$bfserverinfo_template_keys2["!TIMELIMIT"] = the_stripper($bfserverinfo_key2["Time Limit"]);
	$bfserverinfo_template_keys2["!SERVERVERSION"] = the_stripper($bfserverinfo_key2["Version"]);
	$bfserverinfo_template_keys2["!ALLIEDAVGPING"] = the_stripper($bfserverinfo_key2["allied_avg_ping"]);
	$bfserverinfo_template_keys2["!AXISAVGPING"] = the_stripper($bfserverinfo_key2["axis_avg_ping"]);
	$bfserverinfo_template_keys2["!ALLIEDCOUNT"] = the_stripper($bfserverinfo_key["allied_count"]);
	$bfserverinfo_template_keys2["!AXISCOUNT"] = the_stripper($bfserverinfo_key2["axis_count"]);
	$bftmp = the_stripper(strtolower(preg_replace("/\s+/", "_", $bfserverinfo_key2["mapname"])));
	$bftmp = "../mappics/bf/".$bftmp.".jpg";
	if (file_exists($bftmp)) {
		$bfserverinfo_template_keys2["!MAPIMAGENAME"] = the_stripper(strtolower(preg_replace("/\s+/", "_", $bftmp)));
	} else {
		$bfserverinfo_template_keys2["!MAPIMAGENAME"] = "../mappics/nomappic.jpg";
	}
	$bfserverinfo_template_keys2["!ALLIEDAVGSCORE"] = the_stripper($bfserverinfo_key2["allied_avg_score"]);
	$bfserverinfo_template_keys2["!ALLIEDAVGFRAGS"] = the_stripper($bfserverinfo_key2["allied_avg_frags"]);
	$bfserverinfo_template_keys2["!ALLIEDAVGDEATHS"] = the_stripper($bfserverinfo_key2["allied_avg_deaths"]);
	$bfserverinfo_template_keys2["!AXISAVGSCORE"] = the_stripper($bfserverinfo_key2["axis_avg_score"]);
	$bfserverinfo_template_keys2["!AXISAVGFRAGS"] = the_stripper($bfserverinfo_key2["axis_avg_frags"]);
	$bfserverinfo_template_keys2["!AXISAVGDEATHS"] = the_stripper($bfserverinfo_key2["axis_avg_deaths"]);
	$bfserverinfo_template_keys2["!HOSTPORT"] = the_stripper($bfserverinfo_key2["hostport"]);
	$bfserverinfo_template_keys2["!SERVERLOCATION"] = the_stripper($bfserverinfo_key2["serverlocation"]);
	$bfserverinfo_template_keys2["!SERVEROS"] = the_stripper($bfserverinfo_key2["serveros"]);
	
	# Added 7/6/2003
	$bfserverinfo_template_keys2["!ALLIEDTICKETS"] = the_stripper($bfserverinfo_key2["tickets2"]);
	$bfserverinfo_template_keys2["!AXISTICKETS"] = the_stripper($bfserverinfo_key2["tickets1"]);
	$bfserverinfo_template_keys2["!TKMODE"] = the_stripper($bfserverinfo_key2["TK Mode"]);
	$bfserverinfo_template_keys2["!HITINDICATOR"] = the_stripper($bfserverinfo_key2["Hit Indicator"]);
  	$bfserverinfo_template_keys2["!GAMEMODE"] = the_stripper($bfserverinfo_key2["gamemode"]);
	$bfserverinfo_template_keys2["!RESERVEDSLOTS"] = the_stripper($bfserverinfo_key2["reservedslots"]);
	$bfserverinfo_template_keys2["!BFSERVERIP"] = $bfserverinfo_key2["bfserver_ipX"];
	$bfserverinfo_template_keys2["!BFSERVERPORT"] = $bfserverinfo_key2["hostport"];


	if (!isset($allied_team)) {
		$bfserverinfo_template_keys2["!ALLIEDTEAM"] = "<tr><td bcolor=\"\#4D5037\" colspan=\"5\"><font size=\"2\">No Players</font></td></tr>";
	} else {
		$bfserverinfo_template_keys2["!ALLIEDTEAM"] = $allied_team;
	}
	if (!isset($axis_team)) {
		$bfserverinfo_template_keys2["!AXISTEAM"] = "<tr><td bcolor=\"\#4D5037\" colspan=\"5\"><font size=\"2\">No Players</font></td></tr>";
	} else {
		$bfserverinfo_template_keys2["!AXISTEAM"] = $axis_team;
	}
	$include_file = fopen($tf, "r") or die("Could not open $tf");
	while (!feof($include_file)) {
		$bfserver_line = fgets($include_file, 1024);
		foreach (array_keys($bfserverinfo_template_keys2) as $foo) {
			trim($bfserver_line);
			if (preg_match("/$foo/", $bfserver_line, $tempmatch)) {
				$bfserver_line = str_replace("$foo", $bfserverinfo_template_keys2[$foo], $bfserver_line);
			}
		}
		echo $bfserver_line;
	}
	fclose($include_file);
}
?>

